# Class Dialog

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
org.jmol.dialog.Dialog

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible, JmolDialogInterface`

public class Dialog extends JPanel implements JmolDialogInterface

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`Dialog.ExportChoiceListener`
`class`
`Dialog.QualityListener`
`static class`
`Dialog.TypeFilter`

### Nested classes/interfaces inherited from class JPanel

`JPanel.AccessibleJPanel`

### Nested classes/interfaces inherited from class JComponent

`JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected String`
`dialogType`
`protected String[]`
`imageChoices`
`protected String[]`
`imageExtensions`
`protected String`
`imageType`
`protected String`
`inputFileName`
`protected String`
`outputFileName`
`protected int`
`qualityJ`
`protected int`
`qualityP`
`protected Viewer`
`vwr`

### Fields inherited from class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`Dialog()`

## Method Summary

Modifier and Type
Method
Description
`String`
`getFileNameFromDialog(Viewer v, String dType, String iFileName)`
`String`
`getImageFileNameFromDialog(Viewer vwr, String fileName, String type, String[] imageChoices, String[] imageExtensions, int qualityJPG0, int qualityPNG0)`
`String`
`getOpenFileNameFromDialog(Map<String,Object> vwrOptions, Viewer vwr, String fileName, JmolAppAPI jmolApp, String windowName, boolean allowAppend)`
`int`
`getQuality(String sType)`
`String`
`getSaveFileNameFromDialog(Viewer vwr, String fileName, String type)`
`String`
`getType()`
`void`
`setImageInfo(int qualityJPG, int qualityPNG, String imageType)`
`void`
`setupUI(boolean forceNewTranslation)`
`static void`
`setupUIManager()`
Setup the UIManager (for i18n)

### Methods inherited from class JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### imageChoices

protected String[] imageChoices

### imageExtensions

protected String[] imageExtensions

### outputFileName

protected String outputFileName

### dialogType

protected String dialogType

### inputFileName

protected String inputFileName

### vwr

protected Viewer vwr

### qualityJ

protected int qualityJ

### qualityP

protected int qualityP

### imageType

protected String imageType

## Constructor Details

### Dialog

public Dialog()

## Method Details

### getOpenFileNameFromDialog

public String getOpenFileNameFromDialog(Map<String,Object> vwrOptions, Viewer vwr, String fileName, JmolAppAPI jmolApp, String windowName, boolean allowAppend)

Specified by:
  `getOpenFileNameFromDialog` in interface `JmolDialogInterface`

### getSaveFileNameFromDialog

public String getSaveFileNameFromDialog(Viewer vwr, String fileName, String type)

Specified by:
  `getSaveFileNameFromDialog` in interface `JmolDialogInterface`

### getImageFileNameFromDialog

public String getImageFileNameFromDialog(Viewer vwr, String fileName, String type, String[] imageChoices, String[] imageExtensions, int qualityJPG0, int qualityPNG0)

Specified by:
  `getImageFileNameFromDialog` in interface `JmolDialogInterface`

### getType

public String getType()

Specified by:
  `getType` in interface `JmolDialogInterface`
Returns:
  The file type which contains the user's choice

### getQuality

public int getQuality(String sType)

Specified by:
  `getQuality` in interface `JmolDialogInterface`
Parameters:
  `sType` - JPG or PNG
Returns:
  The quality (on a scale from 0 to 100) of the JPEG. 0 to 9 for PNG image that is to be generated. Returns -1 if choice was not JPEG or PNG.

### setupUI

public void setupUI(boolean forceNewTranslation)

Specified by:
  `setupUI` in interface `JmolDialogInterface`

### setupUIManager

public static void setupUIManager()
Setup the UIManager (for i18n)

### setImageInfo

public void setImageInfo(int qualityJPG, int qualityPNG, String imageType)

Specified by:
  `setImageInfo` in interface `JmolDialogInterface`

### getFileNameFromDialog

public String getFileNameFromDialog(Viewer v, String dType, String iFileName)

Specified by:
  `getFileNameFromDialog` in interface `JmolDialogInterface`